Attribute VB_Name = "Add2DL"
Public Sub AddContactsToDL()
'=================================================================
'Description: Outlook macto to create a new contact group or
'             update an existing one with the currently selected
'             contact items.
'
' author : Robert Sparnaaij
' version: 1.0
' website: https://www.howto-outlook.com/howto/addcontactstodl.htm
'=================================================================
    
    Dim oDL As Outlook.DistListItem
    Dim oRecipients As Outlook.Recipients
    Dim oMail As Outlook.MailItem
    Dim objItemsCollection As Object
    Dim objItem As Object
    Dim oSelectedContact As Outlook.ContactItem
    Dim oSelectedDL As Outlook.DistListItem
    Dim oSelection As Outlook.Selection
    Dim CurrentFolder As Outlook.Folder
    Dim Result As Integer
    Dim Found As Boolean
    Dim strDisplayName As String
    Dim strDLName As String
    
    Set CurrentFolder = Application.ActiveExplorer.CurrentFolder
    If CurrentFolder.DefaultItemType <> olContactItem Then
        MsgBox "Please make your selection in a Contacts folder.", vbCritical, "Add Contacts to Contact Group"
        Exit Sub
    End If
    
    strDLName = InputBox("Please specify a name for your Contact Group:", _
                            "Contact Group Name")
    Set objItemsCollection = CurrentFolder.Items.Restrict("[FullName] = '" & strDLName & "'")
    Found = False
    
    If objItemsCollection.Count > 0 Then
        For Each objItem In objItemsCollection
                If objItem.Class = Outlook.olDistributionList Then
                Found = True
                Set oDL = objItem
                Exit For
            End If
        Next
    End If
    
    If Found = True Then
        Result = MsgBox("This Contact Group already exisits." & vbNewLine & _
                        "Would you like to add the selected members to this " & _
                        "Contact Group (Yes) or create it as a new " & _
                        "Contact Group (No)?", vbQuestion + vbYesNoCancel, "Contact Group already exisits")
        If Result = vbYes Then
            'Nothing to do, we already set the oDL to the found object.
        ElseIf Result = vbNo Then
            Set oDL = Application.CreateItem(olDistributionListItem)
            oDL.DLName = strDLName
        Else
            Exit Sub
        End If
    Else
        Set oDL = Application.CreateItem(olDistributionListItem)
        oDL.DLName = strDLName
    End If
    
    Set oMail = Application.CreateItem(olMailItem)
    Set oRecipients = oMail.Recipients
    Set oSelection = Application.ActiveExplorer.Selection
    
    For Each objItem In oSelection
        If objItem.Class = Outlook.olContact Then
            Set oSelectedContact = objItem
            strDisplayName = oSelectedContact.Email1DisplayName
            If Len(strDisplayName) > 0 Then
                oRecipients.Add strDisplayName
            End If
        ElseIf objItem.Class = Outlook.olDistributionList Then
            Set oSelectedDL = objItem
            oRecipients.Add oSelectedDL.DLName
        End If
    Next
    
    oRecipients.ResolveAll
    oDL.AddMembers oRecipients
    oDL.DLName = strDLName
    oDL.Save
    
    Set CurrentFolder = Nothing
    Set objItemsCollection = Nothing
    Set oSelectedDL = Nothing
    Set oMail = Nothing
    Set oRecipients = Nothing
    Set oSelection = Nothing
    Set oSelectedContact = Nothing
    Set oDL = Nothing
        
End Sub


